#include <bits/stdc++.h>
#define ll long long
using namespace std;
int N,K;
string f,podnizovi[2000005];
char S[200005],slova[35];
void prvi_set(){
    int duzina=1<<N;
    bool mat[duzina+5][10];
    for(int i=0;i<=duzina;i++){
            int h=i;
        for(int j=0;j<=6;j++){
            mat[i][j]=h%2;
            h/=2;
        }
    }
    string mat2[duzina+5];

        mat2[1]="a";
        mat2[2]="b";

    for(int i=1;i<=N;i++){
            f.clear();
        for(int j=1;j<=i;j++){
            f.push_back(S[j]);
        }
        if(i==1 or f=="aaa" or f=="aa" or f=="bb" or f=="bbb" or f=="aaaa" or f=="bbbb" or f=="aaaaa" or f=="bbbbb"){cout<<1<<" ";continue;}
        else{
            cout<<2<<" ";
        }

    }

}

int main()
{
    /**ajmo jako**/
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>N>>K;
    for(int i=1;i<=N;i++)cin>>S[i];
    if(N<=5 and K==2){
        prvi_set();
        return 0;
    }
    for(int i=1;i<=K;i++){
        slova[i]=(char)(i+96);
    }
    for(int i=1;i<=N;i++){
            f.clear();
        for(int j=1;j<=i;j++){f+=S[j];
        }

    }
return 0;
}